//*******************************************************
//  ATmega48 8x8 dot matrix LED Display
//
//  file name: disp_8x8_dot.c
//
//@@@PB1:COL1 High:Active
//@@@PB2:COL2 High:Active
//@@@PC5:COL3 High:Active
//@@@PC4:COL4 High:Active
//@@@PC3:COL5 High:Active
//@@@PC2:COL6 High:Active
//@@@PC1:COL7 High:Active
//@@@PC0:COL8 High:Active
//@@@PB0:ROW1 Low:Active
//@@@PD1:ROW2 Low:Active
//@@@PD2:ROW3 Low:Active
//@@@PD3:ROW4 Low:Active
//@@@PD4:ROW5 Low:Active
//@@@PD5:ROW6 Low:Active
//@@@PD6:ROW7 Low:Active
//@@@PD7:ROW8 Low:Active
//
//  2022/11/29  New(TAB4)	taishi for nega48 & Character Mode only, Anode Common only
//*******************************************************

#include	<avr/io.h>
#include	<avr/pgmspace.h>

#include	"mega48_8x8_dot_h.h"
#include	"ofont8x8_h.h"
#include	"disp_8x8_dot_h.h"

// bnkAm[h̎
// _Ci~bN_̃Rƍl镨͂qnvP`WƂ								qnvJ\[h
const unsigned char	row_data_PB_off =0b00000001;	// oâqnvf[^neef[^
const unsigned char	row_data_PB[8]={				//  Rォ牺ɓ
									 0b11111111,	//[0]	// ROW1
									 0b11111111,	//[1]	// ROW2
									 0b11111111,	//[2]	// ROW3
									 0b11111111,	//[3]	// ROW4
									 0b11111111,	//[4]	// ROW5
									 0b11111111,	//[5]	// ROW6
									 0b11111111,	//[6]	// ROW7
									 0b11111110,	//[7]	// ROW8
};
const unsigned char	row_data_PD_off =0b11111111;	// oĉqnvf[^neef[^
const unsigned char	row_data_PD[8]={				//  Rォ牺ɓ
									 0b01111111,	//[0]	// ROW1
									 0b10111111,	//[1]	// ROW2
									 0b11011111,	//[2]	// ROW3
									 0b11101111,	//[3]	// ROW4
									 0b11110111,	//[4]	// ROW5
									 0b11111011,	//[5]	// ROW6
									 0b11111101,	//[6]	// ROW7
									 0b11111111,	//[7]	// ROW8
};

const unsigned char	col_data_PB_off =0b11111001;	// oâbnkf[^neef[^
unsigned char	col_data_PB[8]={
									 0b00000100,	//[0]
									 0b00000010,	//[1]
									 0b00000000,	//[2]
									 0b00000000,	//[3]
									 0b00000000,	//[4]
									 0b00000000,	//[5]
									 0b00000000,	//[6]
									 0b00000000,	//[7]
};
							
const unsigned char	col_data_PC_off =0b11000000;	// ob̂bnkf[^neef[^
unsigned char	col_data_PC[8]={
									 0b00000000,	//[0]
									 0b00000000,	//[1]
									 0b00100000,	//[2]
									 0b00010000,	//[3]
									 0b00001000,	//[4]
									 0b00000100,	//[5]
									 0b00000010,	//[6]
									 0b00000001,	//[7]
};


//***************************
// 8x8 dot Dynamic Dispaly
// 1mS Timer ݂ŌĂ΂
//***************************
void	disp_8x8_dot_led(void)
{
	static	unsigned char	count=0;

	// qnvJ\[h
	PORTB |= row_data_PB_off;		// row off
	PORTD |= row_data_PD_off;		// row off
	PORTB &= col_data_PB_off;		// col off
	PORTC &= col_data_PC_off;		// col off

	PORTB |= col_data_PB[count];	// col set
	PORTC |= col_data_PC[count];	// col set

	PORTB &= row_data_PB[count];	// row set
	PORTD &= row_data_PD[count];	// row set

	count++;
	count &= 0x07;

}
// *****************************
// ƉEւ
// *****************************
unsigned char	get_mirror_data(unsigned char uc)
{
	unsigned char	r = 0;
	unsigned char	bit_s = 0x80;
	unsigned char	bit_d = 0x01;
	unsigned char	i;

	for(i=0;i<8;i++,bit_s >>= 1, bit_d <<= 1){
		if((uc & bit_s) != 0){
			r |= bit_d;
		}
	}
	return(r);

}
// *****************************
// AXL[hbg}gbNXf[^ɕϊ
//	hbg}gNXf[^́@	col_data[8] ɓ
//  ucFAXL[f[^
//  rightFEl
//  mirror_upsidedownFA|̗L 0: 1: 2:| 3:|
// *****************************
void	asc_to_dotmatrix(unsigned char uc,unsigned char	right,unsigned char mirror_upsidedown)
{
	unsigned short	us;
	unsigned char	c;
	unsigned char	i;

	us = uc;
	us &= 0x7f;
	us *= 8;

	for(i=0;i<8;i++){
		c = pgm_read_byte(&font8x8_numchar[us + i]);
		if(0x20 <= c){
			c >>= right;
		}

		if((mirror_upsidedown == 1)||(mirror_upsidedown == 2)){
			c = get_mirror_data(c);									// ƉEւ
		}

		if((mirror_upsidedown == 0)||(mirror_upsidedown == 1)){
			col_data_PC[i] = (c & ~col_data_PC_off);
			col_data_PB[i] = ((c >> 5) & ~col_data_PB_off);
		}else{
			col_data_PC[7-i] = (c & ~col_data_PC_off);
			col_data_PB[7-i] = ((c >> 5) & ~col_data_PB_off);
		}
	}

}
