//*****************************************
//  ATmega48 8x8 dot matrix LED Display
// CPU Clock:8MHz
//   UWlgɂ

//   q[Yf[^́@`FbŃurohdmv
//   @@@@@@@@@uannsryv́uBoot Flash size=4096 words Boot Address=$7000v
//   @@@@@@@@@uanckdudkv́uBrown-out detection at VCC=2.7Vv
//   @@@@@@@@@urtsQbjrdkv́uInt Rc Osc.8MHz,Start-up time:6CK+64msv
//
// File Name:eep_dat.c
//
//  2017/09/13 New TAB4 Taishi
//  2017/12/13 Ver 2.00 Taishi
//  2018/10/25 Modify for Fifteen IN-17 Clock Taishi
//  2019/12/30 Modify for fourteen IN-172 Clock Taishi
//  2020/09/17 Modify for six IN-16 clock Taishi
//  2022/08/23 Modify for pr_six_in17_clock2 Taishi
//  2022/10/24 modify taishi for nega48 & Character Mode only, Anode Common only
//*****************************************
#include	<avr/interrupt.h>
#include	<avr/eeprom.h>

#include	"mega48_8x8_dot_h.h"
#include	"port_bit_h.h"
#include	"timer_h.h"
#include	"uart_h.h"
#include	"eep_dat_h.h"

unsigned char	eep_char_bps EEMEM = 'E';		// ʐMaorw肷镶(A:600 B:1200, C:2400, D:4800, E:9600)
unsigned char	eep_delimiter EEMEM = 0x0d;		// ʐMf~^@bq(0x0d) or ke(0x0a)
unsigned char	eep_target_no EEMEM = 0;		// Ԗڂ̕\邩̔ԍ
unsigned char	eep_right_side_no EEMEM = 0;	// pL̉EliOFlAPFPhbgEړAQFQhbgEړARFRhbgEړiEljj
unsigned char	eep_mirror_touritu EEMEM = 0;	// A|̗L 0: 1: 2:| 3:|
static	unsigned char	eep_bfs[10];

//*****************************************
//@ddoqnl BPS CHAR ǂݍ
//*****************************************
static	unsigned char	read_eep_char_bps(void)
{
	unsigned char	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_byte(&eep_char_bps);		// Ǐo
	if(('A' <= eep_bfs[0])&&(eep_bfs[0] <= 'E')){
		r = eep_bfs[0];
	}else{												// ͈͊O̎
		r = 'E';
		write_eep_char_bps(r);							// ddoqnl BPS CHAR 
	}

	return(r);
}

//*****************************************
//@ddoqnl BPS CHAR 
//*****************************************
void	write_eep_char_bps(unsigned char uc)
{
	eep_bfs[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_char_bps, eep_bfs[0]);		// 
	eeprom_busy_wait();
}
//*****************************************
//@ddoqnl ʐMf~^ ǂݍ
//*****************************************
static	unsigned char	read_eep_delimiter(void)
{
	unsigned char	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_byte(&eep_delimiter);		// Ǐo
	if((0x0a == eep_bfs[0])||(eep_bfs[0] == 0x0d)){
		r = eep_bfs[0];
	}else{												// ͈͊O̎
		r = 0x0d;
		write_eep_delimiter(r);							// ddoqnl ʐMf~^ 
	}

	return(r);
}

//*****************************************
//@ddoqnl ʐMf~^ 
//*****************************************
void	write_eep_delimiter(unsigned char uc)
{
	eep_bfs[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_delimiter, eep_bfs[0]);		// 
	eeprom_busy_wait();
}
//*****************************************
//@ddoqnl \Ԗ ǂݍ
//*****************************************
static	unsigned char	read_eep_target_no(void)
{
	unsigned char	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_byte(&eep_target_no);		// Ǐo
	if(eep_bfs[0] <= 9){
		r = eep_bfs[0];
	}else{												// ͈͊O̎
		r = 0;
		write_eep_target_no(r);							// ddoqnl \Ԗ 
	}

	return(r);
}

//*****************************************
//@ddoqnl \Ԗ 
//*****************************************
void	write_eep_target_no(unsigned char uc)
{
	eep_bfs[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_target_no, eep_bfs[0]);		// 
	eeprom_busy_wait();
}
//*****************************************
//@ddoqnl El ǂݍ
//*****************************************
static	unsigned char	read_eep_right_side_no(void)
{
	unsigned char	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_byte(&eep_right_side_no);		// Ǐo
	if(eep_bfs[0] <= 3){
		r = eep_bfs[0];
	}else{													// ͈͊O̎
		r = 0;
		write_eep_right_side_no(r);							// ddoqnl El 
	}

	return(r);
}

//*****************************************
//@ddoqnl El 
//*****************************************
void	write_eep_right_side_no(unsigned char uc)
{
	eep_bfs[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_right_side_no, eep_bfs[0]);		// 
	eeprom_busy_wait();
}
//*****************************************
//@ddoqnl A|̗L ǂݍ
//*****************************************
static	unsigned char	read_eep_mirror_touritu(void)
{
	unsigned char	r = 0;

	eeprom_busy_wait();
	eep_bfs[0] = eeprom_read_byte(&eep_mirror_touritu);		// Ǐo
	if(eep_bfs[0] <= 3){
		r = eep_bfs[0];
	}else{													// ͈͊O̎
		r = 0;
		write_eep_mirror_touritu(r);						// ddoqnl A|̗L 
	}

	return(r);
}

//*****************************************
//@ddoqnl A|̗L 
//*****************************************
void	write_eep_mirror_touritu(unsigned char uc)
{
	eep_bfs[0] = uc;
	eeprom_busy_wait();
	eeprom_write_byte(&eep_mirror_touritu, eep_bfs[0]);			// 
	eeprom_busy_wait();
}

//*****************************************
//@ddoqnl ۑڂǍ
//*****************************************
void	read_eeprom_save_data(void)
{
	target_number = read_eep_target_no();				// ddoqnl \Ԗ ǂݍ
	bps_character = read_eep_char_bps();				// ddoqnl BPS CHAR ǂݍ
	delimiter_cord = read_eep_delimiter();				// ddoqnl ʐMf~^ ǂݍ
	delimiter_cord = read_eep_delimiter();				// ddoqnl ʐMf~^ ǂݍ
	right_side_no = read_eep_right_side_no();			// ddoqnl El ǂݍ
	mirror_touritu = read_eep_mirror_touritu();			// ddoqnl A|̗L ǂݍ
}
